#include "bits/stdc++.h"

using namespace std;

const int MAXN = 200007;
const int SQ = 500;
set <pair <int, int>> S[SQ];
int values[MAXN];

void update(int id, int value, bool remove = true) {
  int bucket = id/SQ;
  if(remove) S[bucket].erase(make_pair(values[id], id));
  values[id] = value;
  S[bucket].insert(make_pair(values[id], id));
}

int smallest(int l, int r, int v) {
  int bucket_l = l/SQ, bucket_r = r/SQ;
  pair <int, int> res = make_pair(INT_MAX, -1);
  if (bucket_l == bucket_r) {
    for (int i=l; i<=r; i++) {
      if(values[i] > v) res = min(res, make_pair(values[i], i));
    }
  } else {
    for (int i=l; i<(l/SQ+1)*SQ; i++) {
      if(values[i] > v) res = min(res, make_pair(values[i], i));
    }
    for (int i=r/SQ*SQ; i<=r; i++) {
      if(values[i] > v) res = min(res, make_pair(values[i], i));
    }
    for (int i=l/SQ+1; i<r/SQ; i++) {
      auto it = S[i].upper_bound(make_pair(v, MAXN));
      if (it != S[i].end()) res = min(res, *it);
    }
  }
  return res.second;
}

int fastest(int l, int r, int v) {
  int bucket_l = l/SQ, bucket_r = r/SQ;
  if (bucket_l == bucket_r) {
    for (int i=l; i<=r; i++) {
      if(values[i] > v) return i;
    }
  } else {
    for (int i=l; i<(l/SQ+1)*SQ; i++) {
      if(values[i] > v) return i;
    }
    for (int i=l/SQ+1; i<r/SQ; i++) {
      auto it = S[i].rbegin();
      if ((*it).first > v) {
        for (int j=i*SQ; j<(i+1)*SQ; j++) {
          if (values[j] > v) return j;
        }
      }
    }
    for (int i=r/SQ*SQ; i<=r; i++) {
      if(values[i] > v) return i;
    }
  }
  return -1;
}

int main() {
  ios_base::sync_with_stdio(0);
  cin.tie(0); cout.tie(0);
  int N, Q;
  cin >> N >> Q;
  for (int i=0; i<N; i++) {
    cin >> values[i+1];
    update(i+1, values[i+1], false);
  }
  while(Q--) {
    string type;
    cin >> type;
    if (type == "zmiana") {
      int P, Q;
      cin >> P >> Q;
      update(P, Q);
    }
    else {
      int L, R, V;
      cin >> L >> R >> V;
      int res = (type == "najtaniej" ? smallest(L, R, V) : fastest(L, R, V));
      if (res == -1) cout << "NIE\n";
      else cout << res << "\n";
    }
  }
}
